<?php 
class WCOSM_ProductPage
{
	function __construct()
	{
		add_filter( 'woocommerce_get_availability_text', array(&$this, 'set_custom_availability_text'),10,2 );
	}
	function set_custom_availability_text($availability, $product)
	{
		global $wcosm_product_model, $wcosm_text_model;
		$texts = $wcosm_text_model->get_texts();
		
		if ( ! $product->is_in_stock() ) 
			$availability = $texts['out_of_stock'];
		elseif ( $product->managing_stock() && $product->is_on_backorder( 1 ) ) 
			$availability = __( 'Available on backorder', 'woocommerce-out-of-stock-manager' );
		elseif ( $product->managing_stock() ) 
		{
			$availability   = $texts['in_stock_text'];
			$stock_amount = $product->get_stock_quantity();

			/* switch ( get_option( 'woocommerce_stock_format' ) ) 
			{
				case 'low_amount' :
					if ( $stock_amount <= get_option( 'woocommerce_notify_low_stock_amount' ) ) 
						$availability = sprintf( __( 'Only %s left in stock', 'woocommerce' ), $stock_amount );
					break;
				case '' :
					$availability = sprintf( __( '%s in stock', 'woocommerce' ), $stock_amount );
					break;
			} */
			if( $wcosm_product_model->is_product_under_custom_level($product))
				$availability = sprintf( $texts['under_custom_stock_level'], $stock_amount );
			else
				$availability = sprintf( $texts['above_cutom_stock_level'], $stock_amount );

			if ( $product->backorders_allowed() && $product->backorders_require_notification() ) 
				$availability .= ' ' . __( '(can be backordered)', 'woocommerce' );
			
		} 
		else 
			$availability = '';
		
		
		//wcosm_var_dump($wcosm_product_model->is_product_under_custom_level($product));
		return $availability;
	}
}
?>