jQuery(document).ready(function()
{
	var wcosm_stock_manager_widget_date_range_type = 'country';
	var wcosm_stock_manager_widget_picker_start_date;
	var wcosm_stock_manager_widget_picker_end_date;
	var wcosm_stock_manager_data;
	var wcosm_out_of_stock_products_table;
	var wcosm_data_to_update = {};
	jQuery('#wcosm_stock_manager_filter_button').click(wcosm_start_reloading_stock_manager_widget_data);
	//wcosm_set_range_date_selectors(wcosm_stock_manager_widget_date_range_type);
	wcosm_start_reloading_stock_manager_widget_data(null);
	
	jQuery('#wcosm-save-data-button').on('click', wcosm_save_modified_data);
	

function wcosm_start_reloading_stock_manager_widget_data(event)
{
	if(event != null)
	{
		event.stopImmediatePropagation();
		event.preventDefault();
	}
	jQuery('#wcosm_stock_manager_table').fadeOut(500);
	jQuery('#wcosm_stock_manager_stats').fadeOut(500);
	jQuery('#wcosm_stock_manager_wait_box').delay(520).fadeIn(300, function(){ wcosm_reset_stock_manager_widget_canvas(); wcosm_load_new_stock_manager_widget_data()});
}
function wcosm_load_new_stock_manager_widget_data()
{
	var formData = new FormData();
	//wcosm_stock_manager_widget_date_range_type = jQuery('#wcosm_stock_manager_period_range').val();
	formData.append('action', 'wcosm_get_stock_values');
	formData.append('view_type', jQuery('#wcosm_view_type').val());
	//formData.append('max_results_num', jQuery('#wcosm_max_results_num').val());
	
	jQuery.ajax({
		url: ajaxurl, 
		type: 'POST',
		data: formData,
		async: true,
		success: function (data) 
		{
			wcosm_refresh_stock_manager_widget(data);
		},
		error: function (data,error) 
		{
			//alert("Could not contact the server, Error message: "+error);
		},
		cache: false,
		contentType: false, 
		processData: false
	});
}
function wcosm_refresh_stock_manager_widget(data)
{
	
	wcosm_stock_manager_data = jQuery.parseJSON(data); //.zone_name ; .totals ; .order_num
	 /*console.log(data);
	console.log(wcosm_stock_manager_data);  */
	
	wcosm_stock_manager_clear_table();
	jQuery('#wcosm_stock_manager_wait_box').fadeOut(300);
	//jQuery('#wcosm_stock_manager_stats').delay(300).fadeIn(500);
	jQuery('#wcosm_stock_manager_table').delay(300).fadeIn(500, wcosm_render_stock_manager_table);
}


//Table
function wcosm_render_stock_manager_table()
{
	//console.log(wcosm_stock_manager_data);
	var html_string = "";
	 jQuery.each(wcosm_stock_manager_data, function( key, product )
		{
			//console.log(product.post_title+" "+product.sku);
			//if(typeof product !== 'string')
			{
				/* var total_spent = product[11];
				if(isNaN(total_spent))
					total_spent = 0; */
				var category = product.category == null ? " - ": product.category;
				var sku = product.sku == "" ? "N/A" : product.sku;
				
				html_string += '<tr class="wcosm_stock_manager_table_row">';
				html_string += '<td>'+product.ID+'</td>';
				if(!wcosm_is_widget)
					html_string += '<td>'+sku+'</td>';
				html_string += '<td class="wcosm_product_title_column"><span class="wcosm_table_long_text ">'+product.post_title+'</span></td>';
				html_string += '<td><span class="wcosm_table_long_text">'+category+'</span></td>';
				//html_string += '<td>'+product.stock_status+'</td>';
				//html_string += '<td>'+product.product_type+'</td>';
				if(!wcosm_is_widget)
					html_string += '<td>'+parseInt(product.stock_value)+'</td>';
				html_string += '<td><input id="wcosm_stock_value_input_'+product.ID+'" data-type="'+product.product_type+'" data-id="'+product.ID+'" class="wcosm_stock_value_input" type="number" value="'+parseInt(product.stock_value)+'"></input></td>';
				html_string += '</tr>';
			}
		}); 
	jQuery("#wcosm_table_body").html(html_string);
	//Params that differs from widget (dashboard) and full page table
	var unsorable_colum = wcosm_is_widget ? 3 : 5;
	var page_length = wcosm_is_widget ? 10 : 25;
	var order_column = wcosm_is_widget ? 1 : 2;
	//
	wcosm_out_of_stock_products_table = jQuery('#wcosm_product_table').DataTable( {
				"aLengthMenu": [[5, 10, 15, 25, 50, 75, -1], [5, 10, 15, 25, 50, 75, "All"]],
				"pagingType": "full_numbers",
				 "pageLength": page_length,
				 "order": [[ order_column, "desc" ]],
				 "aoColumnDefs": [
					  { 'bSortable': false  , 'aTargets': [ unsorable_colum ]  }
				   ]
			} );
	jQuery('#wcosm_product_table').on( 'draw.dt', function () {
			//console.log(jQuery("input.wcosm_stock_value_input"));
			jQuery("input.wcosm_stock_value_input").on('change', wcosm_add_modified_class_and_store_value);
		} );
	jQuery("#wcosm_product_table").fadeIn(800);
	jQuery("input.wcosm_stock_value_input").on('change', wcosm_add_modified_class_and_store_value);
	
}
function wcosm_save_modified_data(event)
{
	//wcosm_data_to_update = new Array();
	//jQuery(".wcosm_modified").each(function(index,value)
	jQuery.each(wcosm_data_to_update, function(index,value)
	{
		jQuery(value.obj).removeClass("wcosm_modified");
		//jQuery(this).removeClass("wcosm_modified");
		//wcosm_data_to_update[jQuery(this).data('id')] = {id:jQuery(this).data('id'), value:jQuery(this).val()};
	}); 
	
	
	
	if(!wcosm_isEmpty(wcosm_data_to_update))
	//if(wcosm_data_to_update.length > 0)
	{
		jQuery('#wcosm-save-data-button').hide();
		jQuery('#wcosm_loader_during_data_update').show(wcosm_ajax_save_modified_data);
	}
	else
		alert(wcosm_stock_manager_widget_no_data_to_update_error);
}
function wcosm_ajax_save_modified_data(event)
{
	var formData = new FormData();
	formData.append('action', 'wcosm_save_modified_data');
	formData.append('data', JSON.stringify(wcosm_data_to_update));
	
	jQuery.ajax({
		url: ajaxurl, 
		type: 'POST',
		data: formData,
		async: true,
		success: function (data) 
		{
			wcosm_data_to_update = {};
			jQuery('#wcosm-save-data-button').show();
			jQuery('#wcosm_loader_during_data_update').hide();
		},
		error: function (data,error) 
		{
			//alert("Could not contact the server, Error message: "+error);
		},
		cache: false,
		contentType: false, 
		processData: false
	});
}
//Misc
function wcosm_isEmpty(obj) {

    // null and undefined are "empty"
    if (obj == null) return true;

    // Assume if it has a length property with a non-zero value
    // that that property is correct.
    if (obj.length > 0)    return false;
    if (obj.length === 0)  return true;

    // Otherwise, does it have any properties of its own?
    // Note that this doesn't handle
    // toString and valueOf enumeration bugs in IE < 9
    for (var key in obj) {
        if (hasOwnProperty.call(obj, key)) return false;
    }

    return true;
}
function wcosm_add_modified_class_and_store_value(event)
{
	//console.log(jQuery(event.currentTarget).data('id'));
	wcosm_data_to_update[jQuery(event.currentTarget).data('id')] = {id:jQuery(event.currentTarget).data('id'), value:jQuery(event.currentTarget).val(), type: jQuery(event.currentTarget).data('type'), obj:jQuery(event.currentTarget)};
	//console.log(wcosm_data_to_update);
	jQuery(event.currentTarget).addClass("wcosm_modified");
}
function wcosm_stock_manager_clear_table()
{
	try{
		if(wcosm_out_of_stock_products_table && typeof wcosm_out_of_stock_products_table !== 'undefined')
			wcosm_out_of_stock_products_table.destroy();
	}catch(error){}
	jQuery('#wcosm_table_body').empty();
}
function wcosm_set_range_date_selectors()
{
	//if(selector_type == 'daily')
	{
		wcosm_stock_manager_widget_picker_start_date = jQuery( "#wcosm_stock_manager_picker_start_date" ).pickadate({selectMonths: true, selectYears: true, trueformatSubmit: 'yyyy-mm-dd', format: 'yyyy/mm/dd'});
		wcosm_stock_manager_widget_picker_end_date = jQuery( "#wcosm_stock_manager_picker_end_date" ).pickadate({selectMonths: true, selectYears: true, formatSubmit: 'yyyy-mm-dd', format: 'yyyy/mm/dd'});
	}
}

function wcosm_reset_stock_manager_widget_canvas()
{
	/* var myCanvas = jQuery("#wcosm_stock_manager_stats").get(0);
    var ctx = myCanvas.getContext('2d');
    ctx.clearRect(0, 0, myCanvas.width, myCanvas.height) */
	jQuery('#wcosm_stock_manager_stats_canvas_box').empty();
	jQuery('#wcosm_stock_manager_stats_canvas_box').append('<canvas id="wcosm_stock_manager_stats" ></canvas>');
}
function wcosm_stock_manager_getRandomColor() {
    var letters = '0123456789ABCDEF'.split('');
    var color = '#';
    for (var i = 0; i < 6; i++ ) {
        color += letters[Math.floor(Math.random() * 16)];
    }
    return color;
}
});