<?php 
/*
Plugin Name: WooCommerce Out of Stock! Manager
Description: Out of Stock Managment made easy!
Author: Lagudi Domenico
Version: 3.7
*/

/* 
Copyright: WooCommerce Out of Stock! Manager uses the ACF PRO plugin. ACF PRO files are not to be used or distributed outside of the WooCommerce Out of Stock! Manager plugin.
*/

define('WCOSM_PLUGIN_URL', rtrim(plugin_dir_url(__FILE__), "/") ) ;
define('WCOSM_PLUGIN_ABS_PATH', dirname( __FILE__ ) );

if ( in_array( 'woocommerce/woocommerce.php', apply_filters( 'active_plugins', get_option( 'active_plugins' ) ) ) ||
     (is_multisite() && array_key_exists( 'woocommerce/woocommerce.php', get_site_option('active_sitewide_plugins') ))
	)
{
	load_plugin_textdomain('woocommerce-out-of-stock-manager', false, basename( dirname( __FILE__ ) ) . '/languages' );
	
	//com
	include_once( "classes/com/WCOSM_Acf.php");
	
	if(!class_exists('WCOSM_Html'))
		require_once('classes/com/WCOSM_Html.php');
	$wcosm_html_helper = new WCOSM_Html();  
	
	
	if(!class_exists('WCOSM_Option'))
		require_once('classes/com/WCOSM_Option.php');
	$wcosm_option_model = new WCOSM_Option(); 
	
	if(!class_exists('WCOSM_Text'))
		require_once('classes/com/WCOSM_Text.php');
	$wcosm_text_model = new WCOSM_Text(); 
	
	if(!class_exists('WCOSM_Product'))
		require_once('classes/com/WCOSM_Product.php');
	$wcosm_product_model = new WCOSM_Product(); 
	
	if(!class_exists('WCOSM_Wpml'))
		require_once('classes/com/WCOSM_Wpml.php');
	$wcosm_wpml_model = new WCOSM_Wpml(); 
	
	if(!class_exists('WCOSM_Order'))		
		require_once('classes/com/WCOSM_Order.php');
	$wcosm_order_model = new WCOSM_Order(); 
	
	if(!class_exists('WCOSM_Email'))		
		require_once('classes/com/WCOSM_Email.php');
	
	//admin 
	if(!class_exists('WCOSM_ItemList'))		
		require_once('classes/admin/WCOSM_ItemList.php');
	
	if(!class_exists('WCOSM_Dashboard'))
		require_once('classes/admin/WCOSM_Dashboard.php');
	$wcosm_dashboard = new WCOSM_Dashboard(); 
	
	if(!class_exists('WCOSM_OptionPage'))
		require_once('classes/admin/WCOSM_OptionPage.php');
	$wcosm_option_page = new WCOSM_OptionPage(); 
	
	if(!class_exists('WCOSM_TextCustomizerPage'))
		require_once('classes/admin/WCOSM_TextCustomizerPage.php');
	$wcosm_text_customizer_page = new WCOSM_TextCustomizerPage(); 
	
	//frontend 
	if(!class_exists('WCOSM_ProductPage'))		
		require_once('classes/frontend/WCOSM_ProductPage.php');
	$wcosm_product_page = new WCOSM_ProductPage(); 
	
	
	
	
	add_action('plugins_loaded', 'wcosm_on_init');
	add_action('admin_menu', 'wcosm_init_admin_panel');
	//add_action('admin_init', 'wcosm_on_admin_init');
}
function wcosm_on_init()
{
	//$wcosm_option_page = new WCOSM_OptionPage(); 
}
function wcosm_on_admin_init()
{
	//register_setting('wcosm_options_group', 'wcosm_options');
}
function wcosm_init_admin_panel()
{ 
	if(!current_user_can('manage_woocommerce'))
		return;
	
	$place = wcosm_get_free_menu_position(58 , .1);
	add_menu_page( __('Out of stock! Manager', 'woocommerce-out-of-stock-manager'), __('Out of stock! Manager', 'woocommerce-out-of-stock-manager'), 'manage_woocommerce', 'woocommerce-out-of-stock-manager', 'wcosm_load_table_manager', 'dashicons-upload', $place);
	//add_submenu_page('woocommerce-out-of-stock-manager',  __('Itme list', 'woocommerce-out-of-stock-manager'), __('Item list', 'woocommerce-out-of-stock-manager'), 'manage_woocommerce', 'woocommerce-out-of-stock-manager-table-manager', 'wcosm_load_table_manager');
}
function wcosm_load_table_manager()
{
	$item_list = new ItemList();
	$item_list->render_page();
}
function wcosm_get_free_menu_position($start, $increment = 0.3)
{
	foreach ($GLOBALS['menu'] as $key => $menu) {
		$menus_positions[] = $key;
	}

	if (!in_array($start, $menus_positions)) return $start;

	/* the position is already reserved find the closet one */
	while (in_array($start, $menus_positions)) {
		$start += $increment;
	}
	return $start;
}
function wcosm_var_dump($var)
{
	echo "<pre>";
	var_dump($var);
	echo "</pre>";
}
?>